clear;clf;
% define elements on the boundary of a circle
N=12;R=10;Ns=1:N;
dth=2*pi/N;
th=0:dth:2*pi;
xb=R*cos(th);yb=R*sin(th);xe=xb*0;ye=yb*0;
xe(1:N-1)=xb(2:N);xe(N)=xb(1);
ye(1:N-1)=yb(2:N);ye(N)=yb(1);
xm=0.5*(xb+xe);ym=0.5*(yb+ye);
ah=0.5*sqrt((xe-xb).^2+(ye-yb).^2);
calf=0.5*(xe-xb)./ah;salf=0.5*(ye-yb)./ah;
%generate influence matrices
for i=1:N % sending element
   xs=xm(i);ys=ym(i);ci=calf(i);si=salf(i);as=ah(i);
   for j=1:N
      x=xm(j)-xs;y=ym(j)-ys;
      xp=x*ci+y*si;yp=-x*si+y*ci;
      G(j,i)=V(xp,yp,as);
      H(j,i)=VN(xp,yp,as);
   end
end
% set up boundary values of u
%for i=1:N;
%   u(i)=0;
%   if th(i)>= 0 & th(i) <=pi,
%      u(i)=1;
%   end
%end
u=[0*(1:N/2)+1,0*(1:N/2)];
%determine boundary fluxes
p=G\(H*u');
% evaluate the solution at benchmarks
ybm=-R+0.5:0.5:R-0.5;xbm=0*ybm;ubm=0*xbm;
for i=1:N % sending element
   xs=xm(i);ys=ym(i);ci=calf(i);si=salf(i);as=ah(i);
   for j=1:length(ybm)
      x=xbm(j)-xs;y=ybm(j)-ys;
      xp=x*ci+y*si;yp=-x*si+y*ci;
      ubm(j)=ubm(j)+VN(xp,yp,as)*u(i)-V(xp,yp,as)*p(i);
   end
end
rbm=sqrt(xbm.*xbm+ybm.*ybm);thbm=atan2(ybm,xbm);
ue=0.5+atan2(2*R*rbm.*sin(thbm),R^2-rbm.^2)/pi;
figure(1);
subplot(2,1,1),plot(xb,yb,xm(Ns),ym(Ns),'o');
axis square
subplot(2,1,2),plot(ybm,ue,'k-',ybm,ubm,'r-o','markersize',2,'markerfacecolor','r')
xlabel('y')
ylabel('u(0,y)')
legend(' Exact Solution ',' Direct BEM ',2)
title(' Direct boundary integral solution to Laplace Equation: \Deltau=0 along x=0,-10<y<10')
figure(2),plot(ybm,ue-ubm,'r-o','markersize',2,'markerfacecolor','r')
xlabel('y')
ylabel('Error u_ex(0,y)-u(0,y) ')
title(' Direct boundary integral solution to Laplace Equation: \Deltau=0 along x=0,-10<y<10')







      
